import time, random, neopixel
import board
import digitalio
from adafruit_seesaw.seesaw import Seesaw
from adafruit_seesaw.digitalio import DigitalIO
from adafruit_seesaw.pwmout import PWMOut
from adafruit_debouncer import Button
from adafruit_ht16k33 import segments

# Write your code here :-)
import board, digitalio, mount_sd

from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile


from audiomp3 import MP3Decoder

from adafruit_led_animation.color import (
    AMBER, #(255, 100, 0)
    AQUA, # (50, 255, 255)
    BLACK, #OFF (0, 0, 0)
    BLUE, # (0, 0, 255)
    CYAN, # (0, 255, 255)
    GOLD, # (255, 222, 30)
    GREEN, # (0, 255, 0)
    JADE, # (0, 255, 40)
    MAGENTA, #(255, 0, 20)
    OLD_LACE, # (253, 245, 230)
    ORANGE, # (255, 40, 0)
    PINK, # (242, 90, 255)
    PURPLE, # (180, 0, 255)
    RED, # (255, 0, 0)
    TEAL, # (0, 255, 120)
    WHITE, # (255, 255, 255)
    YELLOW, # (255, 150, 0)
    RAINBOW # a list of colors to cycle through
    # RAINBOW is RED, ORANGE, YELLOW, GREEN, BLUE, and PURPLE ((255, 0, 0), (255, 40, 0), (255, 150, 0), (0, 255, 0), (0, 0, 255), (180, 0, 255))
)

INDIGO = (63, 0, 255)
VIOLET = (127, 0, 255)

# We often use these colors, but be sure to check colors used when taking exams
colors = [RED, YELLOW, GREEN]
strip=neopixel.NeoPixel(board.GP16,20)


# set up the speaker
audio = AudioOut(board.GP15) # Assuming you've got tip of speaker plug wired to GP16

path = "/sd/final_sounds/"
beats=["go1.wav","go2.wav","go3.wav","go4.wav"]

# play_sound function - pass in the FULL NAME of file to play
def play_sound(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            pass




filename = "game_music.mp3"
mp3_file = open(path + filename, "rb")
decoder = MP3Decoder(mp3_file)


# Call this function passing in a String for the full filename with extension.
def play_mp3(filename):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        pass # add code here that you want to run while sound plays




button_input = digitalio.DigitalInOut(board.GP6) # Wired to GP15
button_input.switch_to_input(digitalio.Pull.UP) # Note: Pull.UP for external buttons
start_button = Button(button_input) # NOTE: False for external buttons

# The delay on the PWM cycles. Increase to slow down the LED pulsing, decrease to speed it up.
# For most boards.
# i2c = board.I2C()  # uses board.SCL and board.SDA
i2c = board.STEMMA_I2C()  # For using the built-in STEMMA QT connector on a microcontroller
display=segments.Seg14x4(i2c)

display.brightness=1
# For the QT Py RP2040, QT Py ESP32-S2, other boards that have SCL1/SDA1 as the STEMMA QT port.
# import busio
# i2c = busio.I2C(board.SCL1, board.SDA1)
arcade_qt = Seesaw(i2c, addr=0x3A)

# Button pins in order (1, 2, 3, 4)
button_pins = (18, 19, 20, 2)
buttons = []
button_state = [True] * 4  # Initialize all button states to "not pressed"
last_press_time = [0] * 4  # Initialize the time of the last button press to 0 for all buttons
for button_pin in button_pins:
    button = DigitalIO(arcade_qt, button_pin)
    button.direction = digitalio.Direction.INPUT
    button.pull = digitalio.Pull.UP
    buttons.append(button)

# LED pins in order (1, 2, 3, 4)
led_pins = (12, 13, 0, 1)
leds = []
for led_pin in led_pins:
    led = PWMOut(arcade_qt, led_pin)
    led.duty_cycle = 0
    leds.append(led)

mole = random.randint(0,3)
leds[mole].duty_cycle = 65535
score=0
seconds=10
high_score_display=0
high_score=0
timer=False
delay = 0.01
start_time = time.monotonic()
defeat=False
high_score_play=False


def play_sound(filename):
    global defeat
    global high_score_play
    global start_time
    global score
    global mole
    global seconds
    global high_score
    global high_score_display
    global timer
    start_button.update()
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing and seconds:
            elapsed_time = time.monotonic() - start_time
            remaining_time = seconds - int(elapsed_time)
            if remaining_time>0:
                for led_number, button in enumerate(buttons):
                    current_button_time = time.monotonic()
                    if not button.value and button_state[led_number] and (current_button_time - last_press_time[led_number] > 0.1):
                        # Button has been pressed and has been in the "not pressed" state for at least 0.1 seconds
                        button_state[led_number] = False  # Update button state
                        last_press_time[led_number] = current_button_time  # Update last press time
                        leds[led_number].duty_cycle = 0
                        if led_number == mole:
                            score+=1
                            if score>high_score:
                                high_score=score
                                high_score_play=True
                                print(high_score_play)
                            print(mole)
                            print(f"your score: {score}")
                            new_mole = random.randint(0,3)
                            while new_mole==mole:
                                new_mole = random.randint(0,3)
                            mole=new_mole
                            leds[mole].duty_cycle = 65535
                        else:
                            defeat=True
                            seconds=0
                    elif button.value and not button_state[led_number]:
                    # Button has been released
                        button_state[led_number] = True
                if remaining_time<10:
                    time_count = "00:0" + str(remaining_time)
                    display.print(time_count)
                    display.show()
                else:
                    time_count = "00:" + str(remaining_time) # pad with leading 0 if necessary
                    display.print(time_count)
                    display.show()
                print(defeat)
            else:
                break


def play_sound_defeat(filename):
    global defeat
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing and defeat==True:
            display.print("FAIL")
            display.show()
            for i in range(12):
                strip.fill(RED)
                time.sleep(.1)
                strip.fill(BLACK)
                time.sleep(.1)
            defeat=False

def play_sound_high_score(filename):
    global high_score_play
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing and high_score_play==True:
            display.print("HIGH")
            display.show()
            print(f"highscore: {high_score_display}")
            for i in range(12):
                strip.fill(GREEN)
                time.sleep(.1)
                strip.fill(BLACK)
                time.sleep(.1)
            high_score_play =False

while True:
    time_count="00:"+str(seconds)
    start_button.update()
    if start_button.pressed:
        if timer == False:
            timer = True
            mole = random.randint(0,3)
            for x in range(0,3):
                for i in range(0,101):
                    strip.fill(colors[x])
                    strip.brightness=i/100
                for i in range(100,-1,-1):
                    strip.brightness=i/100
            strip.fill(BLACK)
            strip.brightness=1
            start_time = time.monotonic()
            leds[mole].duty_cycle = 65535
        else:
            timer = False
            seconds = 10
            score=0
            for led_number, button in enumerate(buttons):
                leds[led_number].duty_cycle = 0
            high_score_display=0
        print(timer)
        print(seconds)
        print("PRESSED")
    if timer == True:
        elapsed_time = time.monotonic() - start_time
        remaining_time = seconds - int(elapsed_time)
        if defeat==True:
            play_sound_defeat("defeat.wav")
            print(f"defeat highscore: {high_score_display}")
        if remaining_time>0:
            play_sound("game_music.wav")
            print(defeat)
            time.sleep(.2)
            print(remaining_time)
            print(f" remaining time highscore: {high_score_display}")
        if remaining_time <= 0 and defeat== False and high_score_play==True:
            print(f"highscore high : {high_score_display}")
            play_sound_high_score("high_score.wav")
        if remaining_time <= 0 and defeat== False and high_score_play==False:
            strip.fill(RED)
            if len(str(score))==4:
                display.print(str(score))
                display.show()
            elif len(str(score))==3:
                display.print("0"+str(score))
                display.show()
            elif len(str(score))==2:
                display.print("00"+str(score))
                display.show()
            elif len(str(score))==1:
                display.print("000"+str(score))
                display.show()
            for led_number, button in enumerate(buttons):
                leds[led_number].duty_cycle = 0



        if start_button.pressed:
            if timer == False:
                timer = True
                start_time = time.monotonic()
                mole = random.randint(0,3)
                leds[mole].duty_cycle = 65535
    else:
        for led in leds:
            led.duty_cycle = 0
        # reset score to 0
        score = 0
        strip.fill(WHITE)
        if high_score_display==0:
            display.marquee(f"HIGH SCORE:  {high_score}    ", loop=False)
            high_score_display+=1
        display.print("0:00")
        display.show()

